Subject: Re: bug#49204: 28.0.50; How to create new file in project by project-find-file

From: Stefan Monnier <[email-masked]>
Date: Tue, 20 Jul 2021 21:34:27 -0400

Dmitry Gutov [2021-07-21 03:29:43] wrote:
> On 20.07.2021 05:58, Stefan Monnier via Bug reports for GNU Emacs, the Swiss
> army knife of text editors wrote:
>> I haven't followed the discussion, so I might be off, but I think what
>> is described above is something you can get simply by passing the
>> appropriate value for `mustmatch` to `completing-read` and friends
>> (including `read-file-name`).
> Probably not: most third-party completion functions out there don't support
> any non-nil values of that argument other than t (or treat them like t).

Their loss.

> And suppose we chose to use 'confirm', would a neutral prompt "Confirm"
>  without clarification, as opposed to something like "File does not exist;
> Create?", be our best choice?

The same question comes up for `C-x C-f` (and `C-x C-b`).

So far the answer we have chosen is "yes".  We can revisit it,
of course.  Just like we may want to revisit the way `mustmatch` works,
but at least there is an existing "standard protocol" to get that kind
of behavior and I can't think of a good reason why `project-find-file`
should behave very differently from `find-file` in this respect.

        Stefan